#include <genboard.h>

Genboard::Genboard() {

//this->rpmBins[12] = {500,1000,1500,2000,2500,3000,3500,4000,4500,5000,5500,6000};
//this->kpaBins[12] = {10,20,30,40,50,60,70,80,90,100,110,120};

	
	
}

void Genboard::fakeSomeRtValues() {
    
    emit lambdaChanged(0.0);
    emit rpmChanged(0);	
    emit mapChanged(0);
    emit battChanged(0.0);
    emit dcChanged(0);
    emit tpsChanged(0);
    emit cltChanged(0);
    emit iatChanged(0);
    emit gammaChanged(0);
    emit egtChanged(0);
    emit timingChanged(0);
	
}

void Genboard::setRealtimeVar(int var, unsigned char value) {
	if (realtimeVars[var] != value) {
		this->realtimeVars[var] = value;
		switch (var) {
			case 4:
				emit mapChanged(toMap(value));
				break;
			case 5:
				emit iatChanged(toIat(value));
				break;
			case 6:
				emit cltChanged(toClt(value));
				break;
			case 7:
				emit tpsChanged(toTps(value));
				break;
			case 8:
				emit battChanged(toBatt(value));
				break;
			case 9:
				emit lambdaChanged(toLambda(value));
				break;
			case 13:
				emit rpmChanged(toRpm(value));
				break;
			case 14:
				emit dcChanged(toDc(value)); // convert from pw byte to dc percent
				break;
			case 17:
				emit gammaChanged(toGamma(value));
				break;
			case 20:
				emit timingChanged(toTiming(value));
				break;

		}
	}
}

int Genboard::toMap(unsigned char map) {
	return (int)map;
}

int Genboard::toIat(unsigned char iat) {
	return (int)iat;
}

int Genboard::toClt(unsigned char clt) {
	return (int)clt;
}

int Genboard::toTps(unsigned char tps) {
	return (int)(((int)tps)/25.5);
}

float Genboard::toBatt(unsigned char batt) {
	return (float)(((int)batt)/8.5);
}

int Genboard::toRpm(unsigned char rpm) {
	return (((int)rpm)*100);
}

int Genboard::toDc(unsigned char pw) {
	return (int)pw;
}

int Genboard::toGamma(unsigned char gamma) {
	return (int)gamma;
}

int Genboard::toTiming(unsigned char timing) {
	return (int)timing;
}

float Genboard::toLambda(unsigned char lambda) {
	return (float)(((int)lambda)/147.0);
}

