
#ifndef GENBOARD_H
#define GENBOARD_H 

#include <qobject.h>

class Genboard : public QObject
{
    Q_OBJECT
	
public:
    Genboard();
    void fakeSomeRtValues();
    void setRealtimeVar(int var, unsigned char value);
    
protected:
    unsigned char realtimeVars[22];
    int rpmBins[12];
    int kpaBins[12];
    int veTable[12][12];
    int ignitionTable[12][12];
    int lambdaTable[12][12];
    int toMap(unsigned char map);
    int toRpm(unsigned char rpm);
    int toDc(unsigned char pw);
    int toTps(unsigned char tps);
    int toClt(unsigned char clt);
    int toIat(unsigned char iat);
    int toGamma(unsigned char gamma);
    int toTiming(unsigned char timing);
    float toLambda(unsigned char lambda);
    float toBatt(unsigned char batt);
    
signals:
    void lambdaChanged(float lambda);
    void rpmChanged(int rpm);
    void battChanged(float v);
    void dcChanged(int dc);
    void tpsChanged(int tps);
    void cltChanged(int clt);
    void iatChanged(int iat);
    void mapChanged(int map);
    void egtChanged(int egt);
    void timingChanged(int timing);
    void gammaChanged(int gamma);

};

#endif

