#include <qapplication.h>
#include <qmainwindow.h>
#include "mainform.h"
#include "genboard.h"
#include "commscontroller.h"

#ifdef TESTING

#include <cppunit/ui/text/TestRunner.h>
#include "tests.h"

int main()
{
	CppUnit::TextUi::TestRunner runner;
	/* add your test cases here */
	runner.addTest( GenboardRtTest::suite() );

	/* run the tests */
	int result = runner.run("",false,true,true);
	return result;
}


#else

int main( int argc, char ** argv )
{
    QApplication a( argc, argv );
    MainForm w;
    w.show();
    a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );
    
    Genboard g;
    
    /* Connect the Genboard signals to the UI slots */
    a.connect( &g, SIGNAL( lambdaChanged(float) ), &w, SLOT( lambdaRatioChanged(float) ) );
    a.connect( &g, SIGNAL( rpmChanged(int) ), &w, SLOT( rpmChanged(int) ) );
    a.connect( &g, SIGNAL( mapChanged(int) ), &w, SLOT( mapChanged(int) ) );
    a.connect( &g, SIGNAL( iatChanged(int) ), &w, SLOT( iatChanged(int) ) );
    a.connect( &g, SIGNAL( cltChanged(int) ), &w, SLOT( cltChanged(int) ) );
    a.connect( &g, SIGNAL( battChanged(float) ), &w, SLOT( battChanged(float) ) );
    a.connect( &g, SIGNAL( dcChanged(int) ), &w, SLOT( dcChanged(int) ) );
    a.connect( &g, SIGNAL( egtChanged(int) ), &w, SLOT( egtChanged(int) ) );
    a.connect( &g, SIGNAL( gammaChanged(int) ), &w, SLOT( gammaChanged(int) ) );
    a.connect( &g, SIGNAL( timingChanged(int) ), &w, SLOT( timingChanged(int) ) );
    a.connect( &g, SIGNAL( tpsChanged(int) ), &w, SLOT( tpsChanged(int) ) );
    
    /* small connection test */
    g.fakeSomeRtValues();
   
    CommsController *comms = new CommsController(&g);
    comms->start();
    
    return a.exec();
}

#endif

