/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <popup.h>
#include <quickhacktable.h>
#include <iostream>

#define TABLE_COLS 12
#define TABLE_ROWS 12

void MainForm::init() {
    setupTables();
}

void MainForm::setupTables() {
    /* set rows and columns */
    veTable->setNumCols(TABLE_COLS);
    veTable->setNumRows(TABLE_ROWS);
    ignitionTable->setNumCols(TABLE_COLS);
    ignitionTable->setNumRows(TABLE_ROWS);
    lambdaTable->setNumCols(TABLE_COLS);
    lambdaTable->setNumRows(TABLE_ROWS);
  
    /* load some dummy data */
    loadValues();
    
    /* set column width */
    int veColumnWidth = veTable->visibleWidth() / TABLE_COLS;
    int ignitionColumnWidth = ignitionTable->visibleWidth() / TABLE_COLS;
    int lambdaColumnWidth = lambdaTable->visibleWidth() / TABLE_COLS;
    for (int col=0; col<TABLE_COLS; col++) {
	veTable->setColumnWidth (col, veColumnWidth);
	ignitionTable->setColumnWidth (col, ignitionColumnWidth);
	lambdaTable->setColumnWidth (col, lambdaColumnWidth);
    }    
}

void MainForm::loadValues() {
    
    int rpmBins[TABLE_COLS] = {500,1000,1500,2000,2500,3000,3500,4000,4500,5000,5500,6000};
    int kpaBins[TABLE_ROWS] = {120,110,100,90,80,70,60,50,40,30,20,10};
    
    for (int col=0; col<TABLE_COLS;col++) {
	QString string;
	veTable->horizontalHeader()->setLabel(col,(string.setNum(rpmBins[col])));
	ignitionTable->horizontalHeader()->setLabel(col,(string.setNum(rpmBins[col])));
	lambdaTable->horizontalHeader()->setLabel(col,(string.setNum(rpmBins[col])));
    }
    
    for (int row=0; row<TABLE_ROWS;row++) {
	QString string;
	veTable->verticalHeader()->setLabel(row,(string.setNum(kpaBins[row])));
	ignitionTable->verticalHeader()->setLabel(row,(string.setNum(kpaBins[row])));
	lambdaTable->verticalHeader()->setLabel(row,(string.setNum(kpaBins[row])));
    }    
    
}


void MainForm::lambdaSetChanged(float lambda)
{
    QString string;
    lambdaSetSlider->setValue((int)(lambda*100));
    lambdaSetLabel->setText(string.setNum(lambda));
}


void MainForm::lambdaRatioChanged(float lambda )
{
    QString string = QString("%1").arg(lambda,3,'g',2);
    lambdaRatioSlider->setValue((int)(lambda*100));
    lambdaRatioLabel->setText(string);

//    lambdaRatioLabel->repaint();

}


void MainForm::rpmChanged( int rpm )
{
    QString string;
    rpmLabel->setText(string.setNum(rpm));
}


void MainForm::mapChanged( int map )
{
    QString string;
    mapLabel->setText(string.setNum(map));
}


void MainForm::dcChanged( int dc )
{
    QString string;
    dcLabel->setText(string.setNum(dc));
}


void MainForm::tpsChanged( int tps )
{
    QString string;
    tpsLabel->setText(string.setNum(tps));
}


void MainForm::cltChanged( int clt )
{
    QString string;
    cltLabel->setText(string.setNum(clt));
}


void MainForm::iatChanged( int iat )
{
    QString string;
    iatLabel->setText(string.setNum(iat));
}


void MainForm::egtChanged( int egt )
{
    QString string;
    egtLabel->setText(string.setNum(egt));
}


void MainForm::gammaChanged( int gamma )
{
    QString string;
    gammaLabel->setText(string.setNum(gamma));
}


void MainForm::battChanged( float batt )
{
    QString string = QString("%1").arg(batt,3,'g',2);
    battLabel->setText(string);
}



void MainForm::timingChanged( int timing )
{
    QString string;
    timingLabel->setText(string.setNum(timing));
}

