#include <quickhacktable.h>
#include <qpainter.h>

QuickHackTable::QuickHackTable(QWidget *parent, const char *name):QTable(parent, name){
    this->setReadOnly(true);
    this->setSelectionMode(QTable::Single);
    this->setFocusStyle(QTable::FollowStyle);
    this->horizontalHeader()->setResizeEnabled(false);
    this->verticalHeader()->setResizeEnabled(false);
    this->horizontalHeader()->setClickEnabled(false);
    this->verticalHeader()->setClickEnabled(false);
    this->updateHeaderStates();
}

/* handle key presses appropriately */
void QuickHackTable::keyPressEvent ( QKeyEvent * e ) {
    
    QString string;
    int returnCode, binValue;    
    int row  = this->currentRow();
    int col = this->currentColumn();
	
    switch (e->key()) {
    	// see if we got a number...
	case Qt::Key_0:
	case Qt::Key_1:
	case Qt::Key_2:
	case Qt::Key_3:
	case Qt::Key_4:
	case Qt::Key_5:
	case Qt::Key_6:	    
	case Qt::Key_7:
	case Qt::Key_8:	    
	case Qt::Key_9:
	    popup = new PopUp();
	    popup->loadValues(e, this->horizontalHeader()->label(col),this->verticalHeader()->label(row));
	    returnCode = popup->exec();
	    if (returnCode == QDialog::Accepted) {
		// update the table value
		this->setText(row,col,popup->getText());
	    }
	    break;
	// or an increment / decrement key...
	case Qt::Key_Plus:
	    binValue = this->text(row,col).toInt();
	    if (binValue < 200) {
		binValue++;
	    }
	    this->setText(row,col,string.setNum(binValue));
	    break;
	case Qt::Key_Minus:
	    binValue = this->text(row,col).toInt();
	    if (binValue > 0) {
		binValue--;
	    }
	    this->setText(row,col,string.setNum(binValue));
	    break;
	 // if not, do the regular QTable stuff
	default:
	    QTable::keyPressEvent(e);
	    break;
	}
    }
 
